<?php
/**
 * GrShop functions and definitions
 *
 * @link https://developer.wordpress.org/themes/basics/theme-functions/
 *
 * @package GrShop
 */

if (!defined('grshop_grocery_VERSION')) {
	$grshop_grocery_theme = wp_get_theme();
	define('grshop_grocery_VERSION', $grshop_grocery_theme->get('Version'));
}

if ( ! function_exists( 'grshop_grocery_setup' ) ) :
	/**
	 * Sets up theme defaults and registers support for various WordPress features.
	 *
	 * Note that this function is hooked into the after_setup_theme hook, which
	 * runs before the init hook. The init hook is too late for some features, such
	 * as indicating support for post thumbnails.
	 */
	function grshop_grocery_setup() {
		/*
		 * Make theme available for translation.
		 * Translations can be filed in the /languages/ directory.
		 * If you're building a theme based on one-elementor, use a find and replace
		 * to change 'grshop-grocery' to the name of your theme in all the template files.
		 */
		load_theme_textdomain( 'grshop-grocery', get_template_directory() . '/languages' );

		// Add default posts and comments RSS feed links to head.
		add_theme_support( 'automatic-feed-links' );

		/*
		 * Let WordPress manage the document title.
		 * By adding theme support, we declare that this theme does not use a
		 * hard-coded <title> tag in the document head, and expect WordPress to
		 * provide it for us.
		 */
		add_theme_support( 'title-tag' );

		/*
		 * Enable support for Post Thumbnails on posts and pages.
		 *
		 * @link https://developer.wordpress.org/themes/functionality/featured-images-post-thumbnails/
		 */
		add_theme_support( 'post-thumbnails' );

		/* Woocommerce Support */
		add_theme_support( 'woocommerce' );
		add_theme_support( 'wc-product-gallery-zoom' );
		add_theme_support( 'wc-product-gallery-lightbox' );
		add_theme_support( 'wc-product-gallery-slider' );
		// Image Size
		add_image_size('grshop-grocery-blog-thumb', 600, 440, true);
		add_image_size('grshop-grocery-blog-single-thumb', 770, 380, true);
		add_image_size('grshop-grocery-product-cat-thumb', 355, 265, true);

		// This theme uses wp_nav_menu() in one location.
		register_nav_menus(
			array(
				'menu-1' => esc_html__( 'Primary', 'grshop-grocery' ),
			)
		);

		/*
		 * Switch default core markup for search form, comment form, and comments
		 * to output valid HTML5.
		 */
		add_theme_support(
			'html5',
			array(
				'search-form',
				'comment-form',
				'comment-list',
				'gallery',
				'caption',
				'style',
				'script',
			)
		);

		// Set up the WordPress core custom background feature.
		add_theme_support(
			'custom-background',
			apply_filters(
				'grshop_grocery_custom_background_args',
				array(
					'default-color' => 'ffffff',
					'default-image' => '',
				)
			)
		);

		// Add theme support for selective refresh for widgets.
		add_theme_support( 'customize-selective-refresh-widgets' );

		/**
		 * Add support for core custom logo.
		 *
		 * @link https://codex.wordpress.org/Theme_Logo
		 */
		add_theme_support(
			'custom-logo',
			array(
				'height'      => 250,
				'width'       => 250,
				'flex-width'  => true,
				'flex-height' => true,
			)
		);
		
		/*
		* Enable support for wide alignment class for Gutenberg blocks.
		*/
		add_theme_support( 'align-wide' );

		// Add support for Block Styles.
		add_theme_support( 'wp-block-styles' );
		
		
	}
endif;
add_action( 'after_setup_theme', 'grshop_grocery_setup' );

/**
 * Register widget area.
 *
 * @link https://developer.wordpress.org/themes/functionality/sidebars/#registering-a-sidebar
 */
function grshop_grocery_widgets_init() {
	register_sidebar(
		array(
			'name'          => esc_html__( 'Default Sidebar', 'grshop-grocery' ),
			'id'            => 'sidebar',
			'description'   => esc_html__( 'Add widgets here.', 'grshop-grocery' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);
	register_sidebar(
		array(
			'name'          => esc_html__( 'Woocommerce Sidebar', 'grshop-grocery' ),
			'id'            => 'grshop-grocery-woocommerce-sidebar',
			'description'   => esc_html__( 'Add widgets here.', 'grshop-grocery' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);
	register_sidebar( array(
		'name'          => esc_html__( 'Footer Widget 1', 'grshop-grocery' ),
		'id'            => 'grshop-grocery-footer-1',
		'description'   => esc_html__( 'Add footer widget here.', 'grshop-grocery' ),
		'before_widget' => '<div id="%1$s" class="grshop-grocery-footer__widget widget %2$s">',
		'after_widget'  => '</div>',
		'before_title'  => '<h2 class="widget-title">',
		'after_title'   => '</h2>',
	) );
	register_sidebar( array(
		'name'          => esc_html__( 'Footer Widget 2', 'grshop-grocery' ),
		'id'            => 'grshop-grocery-footer-2',
		'description'   => esc_html__( 'Add footer widget here.', 'grshop-grocery' ),
		'before_widget' => '<div id="%1$s" class="grshop-grocery-footer__widget widget %2$s">',
		'after_widget'  => '</div>',
		'before_title'  => '<h2 class="widget-title">',
		'after_title'   => '</h2>',
	) );
	register_sidebar( array(
		'name'          => esc_html__( 'Footer Widget 3', 'grshop-grocery' ),
		'id'            => 'grshop-grocery-footer-3',
		'description'   => esc_html__( 'Add footer widget here.', 'grshop-grocery' ),
		'before_widget' => '<div id="%1$s" class="grshop-grocery-footer__widget widget %2$s">',
		'after_widget'  => '</div>',
		'before_title'  => '<h2 class="widget-title">',
		'after_title'   => '</h2>',
	) );
	register_sidebar( array(
		'name'          => esc_html__( 'Footer Widget 4', 'grshop-grocery' ),
		'id'            => 'grshop-grocery-footer-4',
		'description'   => esc_html__( 'Add footer widget here.', 'grshop-grocery' ),
		'before_widget' => '<div id="%1$s" class="grshop-grocery-footer__widget widget %2$s">',
		'after_widget'  => '</div>',
		'before_title'  => '<h2 class="widget-title">',
		'after_title'   => '</h2>',
	) );
}
add_action( 'widgets_init', 'grshop_grocery_widgets_init' );


/**
 * Enqueue scripts and styles.
 */
function grshop_grocery_scripts() {
	wp_enqueue_style( 'bootstrap', get_template_directory_uri() . '/resource/css/bootstrap.css', array(), '5.1.3' );
	wp_enqueue_style( 'font-awesome-all', get_template_directory_uri() . '/resource/css/font-awesome-all.css', array(), '6.1.1' );
	wp_enqueue_style( 'owl-carousel', get_template_directory_uri() . '/resource/css/owl-carousel.css', array(), '2.2.1' );
	wp_enqueue_style( 'video-popup', get_template_directory_uri() . '/resource/css/modal-video.css', array(), '2.4.6' );
	wp_enqueue_style( 'theme-default', get_template_directory_uri() . '/resource/css/theme-default.css', array(), '1.0.0' );
	wp_enqueue_style( 'grshop-grocery-style', get_stylesheet_uri(), array(), grshop_grocery_VERSION );
	wp_enqueue_script( 'bootstrap', get_template_directory_uri() . '/resource/js/bootstrap.js', array('jquery'), '5.1.3', true );
	wp_enqueue_script( 'owl-carousel', get_template_directory_uri() . '/resource/js/owl-carousel.js', array('jquery'), '2.2.1', true );
	wp_enqueue_script( 'modal-video', get_template_directory_uri() . '/resource/js/modal-video.js', array('jquery'), '2.4.6', true );
	wp_enqueue_script( 'grshop-grocery-navigation', get_template_directory_uri() . '/resource/js/navigation.js', array(), grshop_grocery_VERSION, true );
    wp_enqueue_script( 'jquery-masonry' );
	wp_enqueue_script( 'skip-link-js', get_template_directory_uri() . '/resource/js/skip-link-focus-fix.js', array('jquery'), grshop_grocery_VERSION, true );
	wp_enqueue_script( 'active', get_template_directory_uri() . '/resource/js/active.js', array('jquery'), grshop_grocery_VERSION, true );	

	if ( is_singular() && comments_open() && get_option( 'thread_comments' ) ) {
		wp_enqueue_script( 'comment-reply' );
	}
}
add_action( 'wp_enqueue_scripts', 'grshop_grocery_scripts' );

/**
 * Implement the Custom Header feature.
 */
require get_template_directory() . '/includes/custom-header.php';

/**
 * Custom template tags for this theme.
 */
require get_template_directory() . '/includes/template-tags.php';

/**
 * Functions which enhance the theme by hooking into WordPress.
 */
require get_template_directory() . '/includes/template-functions.php';

/**
 * Theme Font Load.
 */
require get_template_directory() . '/includes/grshop-grocery-theme-font.php';


/**
 * Load TGM plugins for required plugins.
 */
require get_template_directory() . '/includes/tgm/required-plugins.php';

/**
 * Customizer additions.
 */
require get_template_directory() . '/includes/customizer.php';